import isPromise from '../../helpers/isPromise.js';
var GENERIC_ERROR_MESSAGE = 'You might decorate an async function with use @AsyncInlineError';
var _runner = function _runner(_temp) {
  var _ref = _temp === void 0 ? {} : _temp,
    instance = _ref.instance,
    original = _ref.original;
  return function () {
    var response = [];
    Object.defineProperty(response, '__INLINE_ERROR__', {
      enumerable: false,
      writable: true,
      value: true
    });
    var promise = null;
    try {
      for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }
      promise = original.apply(instance, args);
    } catch (error) {
      throw new Error(GENERIC_ERROR_MESSAGE, {
        cause: error
      });
    }
    if (!isPromise(promise)) {
      throw new Error(GENERIC_ERROR_MESSAGE);
    }
    return promise.then(function (r) {
      response[0] = null;
      response[1] = r;
      return response;
    }).catch(function (e) {
      response[0] = e;
      response[1] = null;
      return response;
    });
  };
};
export function AsyncInlineError(config) {
  if (config === void 0) {
    config = {};
  }
  return function (target, fnName, descriptor) {
    var fn = descriptor.value,
      configurable = descriptor.configurable,
      enumerable = descriptor.enumerable;
    return Object.assign({}, {
      configurable: configurable,
      enumerable: enumerable,
      value: function value() {
        var _fnRunner = _runner({
          instance: this,
          original: fn
        });
        for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
          args[_key2] = arguments[_key2];
        }
        return _fnRunner.apply(this, args);
      }
    });
  };
}